import BuffToImg from "./BuffToImg";

export default (img: Image, withAlpha = true) => new Promise((resolve) => {

  const c = document.createElement("canvas");
  c.width = img.width;
  c.height = img.height;

  const ctx = c.getContext("2d");

  const imgEl = new Image(img.width, img.height);
  imgEl.src = BuffToImg(img.data, img.type)



  imgEl.onload = () => {
    ctx.drawImage(imgEl, 0, 0);
    const alphaPixels = ctx.getImageData(0, 0, img.width, img.height).data;

    if (withAlpha) return resolve(alphaPixels);

    const pixelAmount = img.width * img.height;
    const pixels = new Uint8ClampedArray(pixelAmount * 3);

    for (let i = 0; i < pixelAmount; i++) {
      pixels[i * 3 + 0] = alphaPixels[i * 4 + 0];
      pixels[i * 3 + 1] = alphaPixels[i * 4 + 1];
      pixels[i * 3 + 2] = alphaPixels[i * 4 + 2];
    }

    resolve(pixels);
  }

});